<?php

declare(strict_types=1);

namespace Drupal\views_entity_form_row\Form;

use Drupal\Component\Datetime\TimeInterface;
use Drupal\Core\Datetime\DateFormatterInterface;
use Drupal\Core\Entity\EntityRepositoryInterface;
use Drupal\Core\Entity\EntityTypeBundleInfoInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\TempStore\PrivateTempStoreFactory;
use Drupal\node\NodeForm;
use Drupal\views_entity_form_row\ViewsEntityFormRowInfo;
use Symfony\Component\DependencyInjection\ContainerInterface;

class ViewsEntityFormRowNodeForm extends NodeForm {

  use ViewsEntityFormRowTrait;

  private ViewsEntityFormRowInfo $viewsEntityFormRowInfo;

  public function __construct(EntityRepositoryInterface $entity_repository, PrivateTempStoreFactory $temp_store_factory, AccountInterface $current_user, DateFormatterInterface $date_formatter, ViewsEntityFormRowInfo $views_entity_form_row_info, ?EntityTypeBundleInfoInterface $entity_type_bundle_info = NULL, ?TimeInterface $time = NULL) {
    parent::__construct($entity_repository, $temp_store_factory, $entity_type_bundle_info, $time, $current_user, $date_formatter);
    $this->viewsEntityFormRowInfo = $views_entity_form_row_info;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('entity.repository'),
      $container->get('tempstore.private'),
      $container->get('current_user'),
      $container->get('date.formatter'),
      $container->get('views_entity_form_row.info'),
      $container->get('entity_type.bundle.info'),
      $container->get('datetime.time')
    );
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId(): string {
    return $this->doGetFormId();
  }

}
