<?php

namespace Drupal\views_entity_form_row;

use Drupal\Core\Entity\EntityStorageInterface;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\Core\Routing\RouteMatchInterface;
use Drupal\views\ViewEntityInterface;
use Drupal\views_entity_form_row\Plugin\views\row\EntityFormRow;

class ViewsEntityFormRowInfo {
  private EntityStorageInterface $viewStorage;
  private RouteMatchInterface $currentRouteMatch;

  public function __construct(EntityTypeManagerInterface $entity_type_manager, RouteMatchInterface $current_route_match) {
    $this->currentRouteMatch = $current_route_match;
    $this->viewStorage = $entity_type_manager->getStorage('view');
  }

  public function isPluginUsedInCurrentView(): bool {
    $view_id = $this->currentRouteMatch->getParameter('view_id');
    $display_id = $this->currentRouteMatch->getParameter('display_id');
    if ($view_id === NULL || $display_id === NULL) {
      return FALSE;
    }
    $view = $this->viewStorage->load($view_id);
    \assert($view instanceof ViewEntityInterface);
    $view_executable = $view->getExecutable();
    $view_executable->build($display_id);

    return $view_executable->rowPlugin instanceof EntityFormRow;
  }

}
